;These procedures are used to Modify a prior Customer service phone call
; and are contained in the library "CALLSMOD"

Createlib "I:CALLSMOD"

Proc Closed ModServiceCall()
Usevars Libsdir, Clearance

	Readlib Libsdir+"SVCPROC" SysError
	ErrorProc = "SysError"

	Readlib LibsDir + "SvcProc" Notice

	If Clearance > 3 then
		Clear
		Notice("You do not have clearance for this option"," ",
			"Please see your SAT-PLUS Administrator",79,10)
		Sleep 10000
	Endif

	Clearall
	Clear
	Notice("Preparing to Modify Prior Service Phone Calls"," ",
		"Please standby",79,10)
	
	MasterTable = "C:CALLSCR"
	ModCall = "2"				;Form for receiving a New service call

	If not Istable(MasterTable) then
		If not Isempty("CALLSCR") then
			Empty "CALLSCR"
		Endif
		Copy "CALLSCR" MasterTable
		Index Maintained MasterTable on "CALL_KEY2"	;Serial Number
	Endif

	Readlib LibsDir + "CALLSMOD" MSvcCall, HelpCallScr, MovePage, GetNewRec,
						MoveFld, UpdateCalls, NextMach, NextCall, CallDel,
						FindIt, ChkNxtCall

	Readlib LibsDir + "POPINFO" PopInfo
	Readlib LibsDir + "POPUP3" Popup3

	Readlib LibsDir + "SvcProc" SetTime, FindField

	MSvcCall()

	ClearAll
	
EndProc

Writelib "I:CALLSMOD" ModServiceCall
Release Procs All
Release Vars All


Proc MSvcCall()
Private OldCall, n

	Coedit MasterTable
	Pickform ModCall

	If Isempty(MasterTable) then
		Moveto [CALLS->CUST_NAME]
		HOME
		CopyToArray OldCall
		Moveto [C:CALLSCR->CUST_NAME]
		CopyFromArray OldCall
		CopyToArray OldCall
		For n from 2 to 6
			OldCall[n+10] = OldCall[n]
		Endfor
		CopyFromArray OldCall
		[CALL_MODIFIED] = "N"
		[CALL_DELETE] = "N"
	Else
		CopyToArray OldCall
		Moveto [CALLS->CUST_NAME]
		Locate OldCall[12], OldCall[13], OldCall[14], OldCall[15],
			OldCall[16]
		Moveto [C:CALLSCR->CUST_NAME]
	Endif

	Keypress "\f"
	SearchVal = ""
	SearchField = ""
	SearchType = ""

	CurField = Field()
	CurRecno = Recno()
	OldVal = []

	Prompt "[F1] Help   [F2] Prior Machine [F3] Next Machine [F4] Prior Call  [F5] Next Call",
		   "[F6] Search [F7] Repeat Search [F9] Leave        [DEL] Erase or Undo"

	While (true)

		If CurField <> Field() or CurRecno <> Recno()
		  then
			CurField = Field()			;Save name of current field
			CurRecno = Recno()			;Save current record number
		  	OldVal = []
		Endif

		SyncCursor

		WAIT TABLE UNTIL "F1", "F2", "F3","F4", "F5", "F6", "F7", "F8", 
			"F9", "F10", "HOME", "END", "ENTER", "UP", "DOWN", "TAB", 
			"REVERSETAB", "LEFT", "RIGHT", "DEL", "PGUP", "PGDN",
			"CTRLLEFT", "CTRLRIGHT", "CTRLEND", "CTRLPGDN", "CTRLHOME",
			"CTRLPGUP", "CTRLBREAK"
 
		Switch
		case RETVAL = "F1" :		;Help key
			HelpCallScr()

		case RETVAL = "F2" :		;This Customer's previous machine
			NextMach("P")

		case RETVAL = "F3" :		;This Customer's next machine
			NextMach("N")

		case RETVAL = "F4" :		;Service call in CALLS before current one
			NextCall("P")

		case RETVAL = "F5" :		;Service call in CALLS after current one
			NextCall("N")

		case RETVAL = "F6" :		;Search on the current field
			SearchType = FindIt("F","")

		case RETVAL = "F7" :		;Continue same search
			If (IsBlank(SearchType) and
			   (CurField = "CUST_PHONE" or CurField = "CUST_NAME" or
			   CurField = "SERIAL_NO" or CurField = "ASSET_NO")) or
			   (SearchField <> CurField) then
				Notice("An initial Search[F6] must be done on this field",
					"before continuing the search for the same value","",47,17)
				Sleep 5000
			Else
				FindIt("N",SearchType)
			Endif

		case RETVAL = "F9" :
			Showmenu
				"RETURN" : "Return to Modify Prior Calls",
				"LEAVE"  : "Finished Modifying Prior Calls",
				"ABORT"  : "Abort this session and cancel All Modifications"
				Default "RETURN"
			To Choice
			Switch
				case Choice = "RETURN" :
					Loop
				case Choice = "ABORT" :
					MoveFld("X")	;Take care of duplicate keys or other error
					Clear
					Notice("Returning to Main Menu","","",79,10)
					Do_It!
					ClearAll
					Empty MasterTable
					ClearAll
					Return
				case Choice = "LEAVE" :
					x = MoveFld("T")
					If not x then
						Loop
					Endif
					x = UpdateCalls()	;Place Calls in Calls Table
					If not x then		;Duplicate calls or wrong
						LOOP			; field combinations
					Endif
					Clear
					Notice("Returning to Main Menu","","",79,10)
					Do_It!
					Clearall
					Return
			Endswitch

		case RETVAL = "DEL" :
			CallDel()

		case RETVAL = "PGDN" :
			MoveFld("PD")

		case RETVAL = "PGUP" :
			MoveFld("PU")

		case RETVAL = "HOME" :
			MoveFld("H")

		case RETVAL = "END" :
			MoveFld("E")

		case RETVAL = "ENTER" :
			MoveFld("D")

		case RETVAL = "RIGHT" :
			MoveFld("R")

		case RETVAL = "DOWN" :
			MoveFld("D")

		case RETVAL = "TAB" :
			MoveFld("R")

		case RETVAL = "LEFT" :
			MoveFld("L")

		case RETVAL = "UP" :
			MoveFld("U")

		case RETVAL = "REVERSETAB" :
			MoveFld("L")
		
		otherwise:
			Beep

		Endswitch

	Endwhile

Endproc

Writelib "I:CALLSMOD" MSvcCall
Release Procs All
Release Vars All


Proc HelpCallScr()
	Private X, Helparray

	Switch
		case Field() = "CUST_PHONE" :
			Array HelpArray[4]
			HelpArray[1] = "Enter the correct Customer"
			HelpArray[2] = "Phone Number as:"
			HelpArray[3] = "(555) 555-5555 or"
			HelpArray[4] = "555-5555."
			Popinfo(14,25,4,"Phone Number")

		case Field() = "CALL_PROBLEM" :
			Array HelpArray[4]
			HelpArray[1] = "After selecting the correct"
			HelpArray[2] = "Customer and Machine,"
			HelpArray[3] = "provide a description of"
			HelpArray[4] = "the problem."
			Popinfo(14,25,4,"Call Problem")

		case Field() = "SERIAL_NO" :
         	PopUp3(5,5,15,"Choose:","Press [Enter] or [F2] to select",
                "[Esc] to leave Lookup-Help")
			If Oldval <> [] then		;A new Serial Number was selected
				x = GetNewRec(" ")
				If x then
					[CALL_MODIFIED] = "Y"
				Endif
			Endif

		case Field() = "ASSET_NO" :
         	PopUp3(5,10,15,"Choose:","Press [Enter] or [F2] to select",
                "[Esc] to leave Lookup-Help")
			If Oldval <> [] then		;A new Asset Number was selected
				x = GetNewRec(" ")
				If x then
					[CALL_MODIFIED] = "Y"
				Endif
			Endif

		case Field() = "CUST_NAME" :
         	PopUp3(5,40,15,"Choose:","Press [Enter] or [F2] to select",
                "[Esc] to leave Lookup-Help")
			If Oldval <> [] then		;A new Customer Name was selected
				x = GetNewRec(" ")
				If x then
					[CALL_MODIFIED] = "Y"
				Endif
			Endif

	Endswitch
Endproc

Writelib "I:CALLSMOD" HelpCallScr
Release Procs All
Release Vars All


Proc MoveFld(Mov)		;Change field for selection
Private Helparray, Cont	;Mov = "L"eft, "R"ight, "U"p, or "D"own

	If [] <> OldVal then
		If CurField = "CUST_NAME" or	;Field has been changed
		   CurField = "CUST_PHONE" or
		   CurField = "SERIAL_NO" or
		   CurField = "ASSET_NO" then
		  	Cont = GetNewRec(Mov)
			If not Cont then
				Return False
			Endif
		Endif
		[CALL_MODIFIED] = "Y"
	Endif

	Switch

		case Mov = "T" or Mov = "X" :
			Return True

		case Field() = "CUST_NAME" :
			Switch
				case Mov = "R" :
					Moveto [SERIAL_NO]
				case Mov = "L" :
					Moveto [ASSET_NO]
				case Mov = "U" :
					Moveto [CALL_PROBLEM]
				case Mov = "D" :
					Moveto [CUST_PHONE]
				otherwise :
					MovePage(Mov)
			Endswitch
		case Field() = "CUST_PHONE" :
			Switch
				case Mov = "R" :
					Moveto [SERIAL_NO]
				case Mov = "L" :
					Moveto [CUST_NAME]
				case Mov = "U" :
					Moveto [CUST_NAME]
				case Mov = "D" :
					Moveto [SERIAL_NO]
				otherwise :
					MovePage(Mov)
			Endswitch
		case Field() = "CUST_COMMENT" :
			Switch
				case Mov = "R" :
					Moveto [SERIAL_NO]
				case Mov = "L" :
					Moveto [CUST_PHONE]
				case Mov = "U" :
					Moveto [CUST_PHONE]
				case Mov = "D" :
					Moveto [SERIAL_NO]
				otherwise :
					MovePage(Mov)
			Endswitch
		case Field() = "SERIAL_NO" :
			Switch
				case Mov = "R" :
					Moveto [ASSET_NO]
				case Mov = "L" :
					Moveto [CUST_NAME]
				case Mov = "U" :
					Moveto [CALL_PROBLEM]
				case Mov = "D" :
					Moveto [ASSET_NO]
				otherwise :
					MovePage(Mov)
			Endswitch
		case Field() = "ASSET_NO" :
			Switch
				case Mov = "R" :
					Moveto [CUST_NAME]
				case Mov = "L" :
					Moveto [SERIAL_NO]
				case Mov = "U" :
					Moveto [CALL_PROBLEM]
				case Mov = "D" :
					Moveto [CALL_PROBLEM]
				otherwise :
					MovePage(Mov)
			Endswitch
		case Field() = "CALL_PROBLEM" :
			Switch
				case Mov = "R" :
					Moveto [CUST_NAME]
				case Mov = "L" :
					Moveto [CUST_NAME]
				case Mov = "U" :
					Moveto [CUST_NAME]
				case Mov = "D" :
					Moveto [CUST_NAME]
				otherwise :
					MovePage(Mov)
			Endswitch
	Endswitch

Endproc

Writelib "I:CALLSMOD" MoveFld
Release Procs All
Release Vars All


Proc MovePage(Mov)
Private NxtCall

	If Isblank([SERIAL_NO])
	  then
		DEL				;Serial Number must not be blank
	Endif

	Switch
		case Mov = "PD" :		;PGDN
			If Atlast()
			  then
			  	Beep
				Return
			else
				If [CALL_MODIFIED] = "N" and [CALL_DELETE] = "N" then
					DEL
				Else
					PGDN PGDN
				Endif
			Endif

		case Mov = "PU" :		;PGUP
			If Atfirst()
			  then
			  	Beep
				Return
			else
				If [CALL_MODIFIED] = "N" and [CALL_DELETE] = "N" then
					If Atlast() then
						DEL
					Else
						DEL PGUP PGUP
					Endif
				Else
					PGUP PGUP
				Endif
			Endif

		case Mov = "H" :		;Home
			If Atfirst()
			  then
			  	Beep
				Return
			else
				If [CALL_MODIFIED] = "N" and [CALL_DELETE] = "N" then
					DEL
				Endif
				HOME
			Endif
			
		case Mov = "E" :		;End
			If Atlast()
			  then
			  	Beep
				Return
			else
				If [CALL_MODIFIED] = "N" and [CALL_DELETE] = "N" then
					DEL
				Endif
				END
			Endif

	Endswitch

	Moveto [C:CALLSCR->CUST_NAME]
	CopyToArray NxtCall
	Moveto "CALLS"
	Locate NxtCall[12], NxtCall[13], NxtCall[14], NxtCall[15], NxtCall[16]
	Moveto [C:CALLSCR->CUST_NAME]
	CurRecno = 0

Endproc

Writelib "I:CALLSMOD" MovePage
Release Procs All
Release Vars All



Proc GetNewRec(Mov)	;A key field has been changed, get the associated
						; Equipment Record. CurField should be set to Field()
Private EqCount, FirstEq, X, Y, ThisRec, CurRecd

	CurRecno = 0
	CopyToArray ThisRec		;Save for retrieval
	If CurField = "SERIAL_NO" or CurField = "ASSET_NO" then
		If not Isblank([CUST_NAME]) then
			Unlockrecord
			X = Retval
			Y = ErrorCode()
			CopyToArray CurRecd
			If ThisRec[2] <> CurRecd[2] or	;Unlockrecord moved position
			   ThisRec[3] <> CurRecd[3] or	
			   ThisRec[4] <> CurRecd[4] or
			   ThisRec[5] <> CurRecd[5] or
			   ThisRec[6] <> CurRecd[6] then
				Locate ThisRec[2], ThisRec[3], ThisRec[4], ThisRec[5],
					ThisRec[6]
			Endif
			If not X and Y <> 54 then		;Duplicate call
				If Mov <> "X" then
					If Y = 53 then
						Notice("A Call has already been modified by you",
							"for Customer "+[CUST_NAME],"S/N "+[SERIAL_NO]+
							", Asset No. "+[ASSET_NO],47,17)
					Else
						Notice("Unable to save this record",Errormessage(),
							"Press any key to continue",47,17)
					Endif
					While not Charwaiting()
					Endwhile
					X = Getchar()	;Throw away key press
				Endif
				[] = Oldval
				Return False
			Endif
		Endif
	Endif

	If Isblank([]) or Mov = "X" or
	  Mov = "T" then	;Do nothing else
		Return True
	Endif

	Moveto "CALLSLU"
	Moveto Field CurField

	Locate ThisRec[CurField]
	If not Retval then		;This customer has no machines
		Moveto MasterTable
		Moveto Field CurField
		Switch
		case CurField = "CUST_NAME" :
			Notice("The Customer "+ThisRec[CurField],
				"has no machines on file","Press any key to continue",47,17)
		case CurField = "CUST_PHONE" :
			Notice("The Customer at "+ThisRec[CurField],
				"has no machines on file","Press any key to continue",47,17)
		case CurField = "SERIAL_NO" :
			Notice("Unable to locate a machine with a","Serial Number: "+
				ThisRec[CurField],"Press any key to continue",47,17)
		case CurField = "ASSET_NO" :
			Notice("Unable to locate a machine with an","Asset Number: "+
				ThisRec[CurField],"Press any key to continue",47,17)
		Endswitch
		[] = Oldval
		While not Charwaiting()
		Endwhile
		X = Getchar()	;Throw away key press
		Return False
	Endif

	EqCount = 0
	CopyToArray FirstEq

	If CurField = "CUST_NAME" or
	   CurField = "CUST_PHONE" then	;Find how many machines this customer has
		Moveto [CUST_NAME]		;CALLSLU table
		Retval = True
		While Retval
			EqCount = EqCount+1
			If Atlast() then
				Quitloop
			Endif
			DOWN		;Next record
			Locate Next FirstEq["CUST_NAME"]
		Endwhile
		
		Notice("The Customer "+FirstEq["CUST_NAME"],"has "+
			Strval(EqCount)+" machine(s).","Press any key to continue",47,17)
		If EqCount > 1 then
			Locate FirstEq["CUST_NAME"]	;Move back to customer's first machine
		Endif
		While not Charwaiting()	;Wait for key press
		Endwhile
		X = Getchar()	;Throw away key press
	Endif

	Moveto MasterTable
	CopyToArray CurRecd
	If ThisRec[2] <> CurRecd[2] or	;Unlockrecord move position
	   ThisRec[3] <> CurRecd[3] or	
	   ThisRec[4] <> CurRecd[4] or
	   ThisRec[5] <> CurRecd[5] or
	   ThisRec[6] <> CurRecd[6] then
		Locate ThisRec[2], ThisRec[3], ThisRec[4], ThisRec[5],
			ThisRec[6]
	Endif
	Moveto Field CurField
	[CUST_NAME] = FirstEq["CUST_NAME"]
	[SERIAL_NO] = FirstEq["SERIAL_NO"]
	[ASSET_NO] = FirstEq["ASSET_NO"]
	[CUST_PHONE] = FirstEq["CUST_PHONE"]
	[CALL_DATE] = Today()
	[CALL_TIME] = SetTime()
	[CALL_OPERATOR] = Username()
	CopyToArray ThisRec

	UnlockRecord
	If Errorcode() = 53 then	;Go to duplicate if any
		Keypress -38			; ALT-L
	Endif

	CopyToArray CurRecd
	If ThisRec[2] <> CurRecd[2] or	;Unlockrecord move position
	   ThisRec[3] <> CurRecd[3] or
	   ThisRec[4] <> CurRecd[4] or
	   ThisRec[5] <> CurRecd[5] or
	   ThisRec[6] <> CurRecd[6] then
		Locate ThisRec[2], ThisRec[3], ThisRec[4], ThisRec[5],
			ThisRec[6]
	Endif
	Return True

Endproc

Writelib "I:CALLSMOD" GetNewRec
Release Procs All
Release Vars All





Proc UpdateCalls()
Private x, n, C1, OldCall, Errmsg

	Clear
	Notice("Placing the Modified Calls in the Calls Table",Fill(" ",60),
		"Please standby",79,10)
	Do_It!
	Clearall

	If Isempty(MasterTable) then		;There are no calls to post
		Style Attribute 79
		@12,11 ?? Format("W58,AC","No Calls were changed")
		Sleep 3000
		Style
		Return True
	Endif

	Query

	 C:callscr | CALL_MODIFIED | CALL_DELETE | 
	 DELETE    | N             | N           | 
	           |               |             | 
	           |               |             | 

	 C:callscr | 
	           | 
	           | 
	           | 

	Endquery
	Do_It!

	If Istable("DELETED") then
		Delete "DELETED"
	Endif
	Clearall

	If Isempty(MasterTable) then		;There are no calls to post
		Style Attribute 79
		@12,11 ?? Format("W58,AC","No Calls were changed")
		Sleep 3000
		Style
		Return True
	Endif

	View "CALLSLU"
	View "CALLS"
	Coedit MasterTable

	x = NRecords(MasterTable)
	n = 1
	Style Attribute 79

	While n <= x
		@12,11 ?? Format("W58,AC","Record "+Strval(n)+" of "+Strval(x))
		Moveto Record n
		CopyToArray C1
		UPIMAGE			;CALLS
		UPIMAGE			;CALLSLU
			;Verify that the key field combinations identify a valid machine
		Locate C1[2], C1[3], C1[4]	;Cust_name, Serial_no, Asset_no
		If Retval then
			DOWNIMAGE	;CALLS, Find the associated call
			Locate C1[12], C1[13], C1[14], C1[15], C1[16]
			If Retval then		;Modify or delete the Call
				LOCKRECORD		;Make sure record is available
				If Retval then
					If C1["CALL_DELETE"] = "Y" then
						DEL
					Else					;Modify flag is set
						CopyFromArray C1
						UNLOCKRECORD
						If not Retval then	;Must have been saved by another
											; operator
							UNLOCKRECORD
						Endif
					Endif
					DOWNIMAGE		;Mastertable
					DEL				;Finished with this record
					x = x - 1
				Else			;Record is not available to be modified
					Errmsg = Errormessage()
					Notice("Unable to save the Modified Call for",
						C1[2]+" S/N: "+C1[3]+" A/N: "+C1[4],
						"Reason: "+Errmsg,47,17)
					Sleep 5000
					DOWNIMAGE		;Mastertable
					n = n + 1
				Endif
			Else
				DOWNIMAGE		;Mastertable
				n = n + 1
			Endif
		Else				;This is not a valid equipment record
			DOWNIMAGE		;CALLS
			DOWNIMAGE		;Mastertable
			n = n + 1
		Endif
	Endwhile

	Do_It!
	Clearall
	Style

	If Isempty(MasterTable) then	;All is finished
		Return True
	Endif

		;Otherwise, duplicate calls were found


	Notice("There are duplicate records or","invalid field combinations.",
		"Please correct before continuing",47,17)

	Coedit MasterTable
	Pickform ModCall

	CopyToArray OldCall
	Moveto [CALLS->CUST_NAME]
	Locate OldCall[12], OldCall[13], OldCall[14], OldCall[15],
		OldCall[16]
	Moveto [C:CALLSCR->CUST_NAME]

	CurField = Field()
	CurRecno = Recno()
	OldVal = []

	Prompt "[F1] Help   [F2] Prior Machine [F3] Next Machine [F4] Prior Call  [F5] Next Call",
		   "[F6] Search [F7] Repeat Search [F9] Leave        [DEL] Erase or Undo"

	Moveto [C:CALLSCR->CUST_NAME]

	Return False

Endproc

Writelib "I:CALLSMOD" UpdateCalls
Release Procs All
Release Vars All




Proc NextMach(Mov)	;Get the next machine for the selected Customer
Private Foundit,	; "P"rior machine, "N"ext machine
	ThisRec, GetPrev, CurRecd

	Foundit = False
	CopyToArray ThisRec
	Unlockrecord
	If Errorcode() = 53 then	;Duplicate record
		Keypress -38			;ALT-L
	Endif
	CopyToArray CurRecd
	If ThisRec[2] <> CurRecd[2] or	;Unlockrecord move position
	   ThisRec[3] <> CurRecd[3] or	
	   ThisRec[4] <> CurRecd[4] or
	   ThisRec[5] <> CurRecd[5] or
	   ThisRec[6] <> CurRecd[6] then
		Locate ThisRec[2], ThisRec[3], ThisRec[4], ThisRec[5], ThisRec[6]
	Endif
	Moveto [CALLSLU->CUST_NAME]
	Locate ThisRec["CUST_NAME"], ThisRec["SERIAL_NO"],
		ThisRec["ASSET_NO"]

						; The following depends upon the CALLSLU table being
						;   in CUSTOMER NAME ORDER

	If Retval then		;Found current machine, now find the next or previous
		Foundit = True
		Switch
		case Mov = "N" :	;Get the next machine for this customer
			If Atlast() then	;There are no more machines this direction
				Foundit = False
			Else
				DOWN			;Next Record
			Endif
		case Mov = "P" :	;Get the previous machine for this customer
			If Atfirst() then	;There are no more machines this direction
				Foundit = False
			Else
				UP
			Endif
		Endswitch
		Moveto [C:CALLSCR->CUST_NAME]
		If [CUST_NAME] = [CALLSLU->CUST_NAME] and 
		  Foundit then 		;Found the next machine
			Foundit = True
			[SERIAL_NO] = [CALLSLU->SERIAL_NO]
			[ASSET_NO]  = [CALLSLU->ASSET_NO]
			Keypress "\f"	;Resync
		Else
			Foundit = False
		Endif
		If Foundit then
			[CALL_MODIFIED] = "Y"	;A new machine has been selected
		Else
			Switch
			case Mov = "N" :
				Notice("This is the last machine for",[CUST_NAME],
					"Press any key to continue",47,17)
			case Mov = "P" :
				Notice("This is the first machine for",[CUST_NAME],
					"Press any key to continue",47,17)
			Endswitch
			While not Charwaiting()
			Endwhile
			X = Getchar()	;Throw away key press
		Endif

	Else			;Invalid field combination, get the current Customer's
					; machine, if any
		If Isblank([C:CALLSCR->CUST_NAME]) then
			Notice("A Customer must be selected before",
				"finding the Next or Previous Machine.",
				"Press any key to continue",47,17)
			Moveto [C:CALLSCR->CUST_NAME]
			While not Charwaiting()
			Endwhile
			X = Getchar()	;Throw away key press
		Else
			Moveto [CUST_NAME]
			Locate [C:CALLSCR->CUST_NAME]
			If Retval then
				Moveto [C:CALLSCR->CUST_NAME]
				[SERIAL_NO] = [CALLSLU->SERIAL_NO]
				[ASSET_NO]  = [CALLSLU->ASSET_NO]
				Keypress "\f"	;Resync
				[CALL_MODIFIED] = "Y"	;A new machine has been selected
			Else
				Notice("The Customer "+[C:CALLSCR->CUST_NAME],
					"has no machines on file","Press any key to continue",
					47,17)
				Moveto [C:CALLSCR->CUST_NAME]
				While not Charwaiting()
				Endwhile
				X = Getchar()	;Throw away key press
			Endif
		Endif
	Endif

	If not Isblank(Mov) then
		CurRecno = Recno()	;Oldval should not be updated
	Endif
Endproc

Writelib "I:CALLSMOD" NextMach
Release Procs All
Release Vars All




Proc NextCall(Mov)		;Get the next or previous Customer Call in the
Private ThisRec, x,	; Calls Table, "P"rior, "N"ext
	Rcdno, SaveRec, ModdCall, ChkRec


	If not Isblank(Mov) then
		CurRecno = 0		;Have Oldval updated
		x = MoveFld("T")	;Verify mofification
		If not x then
			Return
		Endif
	Endif

	Moveto [CALLS->CUST_NAME]

	Switch
	case Mov = "P" :	;Get the Prior Customer Call
		If Atfirst() then
			Beep
			Notice("Already at first Customer Call"," ",
				"Press any key to continue",47,17)
			While not Charwaiting()	;wait for key press
			Endwhile
			x = GetChar()	;throw away key
			Moveto [C:CALLSCR->CUST_NAME]
			Return
		Else
			UP
		Endif
	case Mov = "N" :	;Get the Next Customer Call
		If Atlast() then
			Beep
			Notice("Already at last Customer Call"," ",
				"Press any key to continue",47,17)
			While not Charwaiting()	;wait for key press
			Endwhile
			x = GetChar()	;throw away key
			Moveto [C:CALLSCR->CUST_NAME]
			Return
		Else
			DOWN
		Endif
	Endswitch

	ModdCall = ChkNxtCall()	;See if call is already in CALLSCR

	If ModdCall then			;The next or prior call is already in the
								; CALLSCR table
		Moveto [C:CALLSCR->CUST_NAME]
	Else						;Place call in the CALLSCR table
		CopyToArray ThisRec		;Save the next or prior call record

		Moveto [C:CALLSCR->CUST_NAME]

		If [CALL_DELETE] = "Y" or [CALL_MODIFIED] = "Y" then
			END
			INS
		Endif

		CopyFromArray ThisRec
		CopyToArray ThisRec
		For x from 2 to 6		;Save unmodified key fields
			ThisRec[x+10] = ThisRec[x]
		Endfor
		ThisRec["CALL_MODIFIED"] = "N"
		ThisRec["CALL_DELETE"] = "N"
		CopyFromArray ThisRec

		UnlockRecord
		CopyToArray ChkRec
		If ChkRec[2] <> ThisRec[2] or
		   ChkRec[3] <> ThisRec[3] or
		   ChkRec[4] <> ThisRec[4] or
		   ChkRec[5] <> ThisRec[5] or
		   ChkRec[6] <> ThisRec[6] then	;Unlock moved record position
		  	Locate ThisRec[2], ThisRec[3], ThisRec[4], ThisRec[5],
		  		ThisRec[6]
		Endif
	Endif

	Keypress "\f"				;Resync nested tables

Endproc

Writelib "I:CALLSMOD" NextCall
Release Procs All
Release Vars All




Proc CallDel()			;Flag the Call to be deleted or Undo all changes
Private OldCall, Choice, NewCall, x, Restoreit

	Showmenu
		"RETURN" : "Return to Modify Prior Service Calls",
		"DELETE" : "Flag this Call to be Removed from the Call Table",
		"UNDO"   : "Undo the changes to this Call"
		Default "RETURN"
	To Choice
	Switch
		case Choice = "UNDO" :
			CopyToArray NewCall
 			MoveFld("X")	;Take care of duplicate keys or other error
			Moveto [CALLS->CUST_NAME]
			CopyToArray OldCall
			Restoreit = True
			If OldCall[2] <> NewCall[12] and
			   OldCall[3] <> NewCall[13] and
			   OldCall[4] <> NewCall[14] and
			   OldCall[5] <> NewCall[15] and
			   OldCall[6] <> NewCall[16] then
				Locate NewCall[12], NewCall[13], NewCall[14], NewCall[15],
					NewCall[16]
				If Retval then
					CopyToArray OldCall
				Else
					Notice("Unable to restore original Call",
						"This call might have been deleted by another operator",
						"Press any key to continue",47,17)
					Restoreit = False
					While not Charwaiting()
					Endwhile
					x = GetChar()
				Endif
			Endif
			Moveto [C:CALLSCR->CUST_NAME]
			If Restoreit then
				CopyFromArray OldCall
				[CALL_DELETE] = "N"
				[CALL_MODIFIED] = "N"
			Endif
			CurRecno = 0

		case Choice = "DELETE" :
			[CALL_DELETE] = "Y"
			Notice("Call will be deleted from the Calls Table",
				"when this session is completed.",
				"Press any key to continue",47,17)
			While not Charwaiting()
			Endwhile
			x = GetChar()

		case Choice = "RETURN" :
			Return

	Endswitch

Endproc

Writelib "I:CALLSMOD" CallDel
Release Procs All
Release Vars All




Proc FindIt(ForN,ContChoice)	;Allow search to be on Changed calls, existing
Private x, Choice,				; calls, or equipment
	ThisVal, NewVal, RcdNo

	x = MoveFld("T")	;Verify and flag current record before leaving it
	If not x then
		Return ""
	Endif

	If CurField <> "CUST_NAME" and
	   CurField <> "CUST_PHONE" and
	   CurField <> "SERIAL_NO" and
	   CurField <> "ASSET_NO" then
		If x then
			x = FindField(ForN)
			If x then
				CurRecno = Recno()	;Oldval should not be updated
			Endif
		Endif
		Return ""
	Endif

	If ForN = "F" then
		Switch
		case CurField = "CUST_PHONE" :
			Showmenu
				"RETURN"	: "Return to Modify Prior Service Calls",
				"MODIFIED"	: "Find a Service Call that you have changed this session",
				"EQUIPMENT"	: "Find an existing Machine"
				Default "RETURN"
			To Choice

		otherwise :
			Showmenu
				"RETURN"	: "Return to Modify Prior Service Calls",
				"MODIFIED"	: "Find a Service Call that you have changed this session",
				"CALL"		: "Find an existing Service Call",
				"EQUIPMENT"	: "Find an existing Machine"
				Default "RETURN"
			To Choice
		Endswitch
	Else		;"N"ext or continue search was selected
		Choice = ContChoice
	Endif

	Switch
	case Choice = "RETURN" :
		Return ""

	case Choice = "MODIFIED" :	;Find a call already modified
		FindField(ForN)
		CurRecno = 0

	case Choice = "CALL" :	;Find another call to modify
		Moveto "CALLS"
		RcdNo = Recno()
		Moveto Field CurField
		x = FindField(ForN)
		If x then
			NewVal = []
			Moveto MasterTable
			Moveto Field CurField
			[] = NewVal
			NextCall("")
			Moveto Field CurField
			CurRecno = 0
		Else				;No new record was found
			Moveto Record RcdNo
			Moveto MasterTable
			Moveto Field CurField
		Endif

	case Choice = "EQUIPMENT" :
		Moveto "CALLSLU"
		RcdNo = Recno()
		Moveto Field CurField
		x = FindField(ForN)
		If x then
			NewVal = []
			Moveto MasterTable
			Moveto Field CurField
			[] = NewVal
			NextMach("")
			Moveto Field CurField
			CurRecno = Recno()	;Oldval should not be changed until field
								; or record is left
		Else					;No new record was found
			Moveto Record RcdNo
			Moveto MasterTable
			Moveto Field CurField
		Endif

	Otherwise :
		Return ""
	Endswitch

	Return Choice
Endproc

Writelib "I:CALLSMOD" FindIt
Release Procs All
Release Vars All




Proc ChkNxtCall()	;See if this Call has already been modified this session
Private NxtCall, Recd, Foundit

	CopyToArray NxtCall				;Save the Call being checked
	Moveto [C:CALLSCR->CALL_KEY2]	;Secondary Index, original serial number
	Recd = Recno()
	Foundit = False
	HOME

	While True
		Locate Next NxtCall["SERIAL_NO"]	;Find all with this serial number
		If Retval then
			If [CALL_KEY1] = NxtCall[2] and		;Customer name
;already checked [CALL_KEY2] = NxtCall[3] and		;Serial Number
			 [CALL_KEY3] = NxtCall[4] and		;Asset Number
			 [CALL_KEY4] = NxtCall[5] and		;Call Date
			 [CALL_KEY5] = NxtCall[6] then		;Call Time
				Recd = Recno()
				Foundit = True
				Quitloop
			Endif
		Else
			Quitloop		;There are no more calls with this serial number
		Endif
		If Atlast() then
			Quitloop
		Endif
		Moveto Record Recno()+1		;Continue search with next Modified Call
	Endwhile

	Moveto Record Recd
	If Foundit then					;If the next or prior call is already here
		CopyToArray NxtCall			;Get the Modified Call record found
		Moveto Record Recd
		If [CALL_MODIFIED] = "N" and [CALL_DELETE] = "N" then
			DEL
			Locate NxtCall[2], NxtCall[3], NxtCall[4], NxtCall[5], NxtCall[6]
		Endif
		Moveto [CALLS->CUST_NAME]	;and find its associated Call record
		Locate NxtCall[12], NxtCall[13], NxtCall[14], NxtCall[15], NxtCall[16]
	Else
		Moveto [CALLS->CUST_NAME]
	Endif
	Return Foundit

Endproc

Writelib "I:CALLSMOD" ChkNxtCall
Release Procs All
Release Vars All

