PROC Closed Notice(prompt1,prompt2,prompt3,S,L)
    
;PRIVATE w,wb,c,width,prompt_counter,topline,botline,shadowrow,shadowcol,n1
    
    
    ; prompt1  prompt2  and prompt3 are the text lines to be placed in the box.
    ; A  max of 74 characters is permitted to allow for border.
    ; If Len(Prompt#)>74 then Substr(Prompt#,1,74) will be used
    ; Any or all of the prompts may be used, the box height is adjusted accordingly.
    
    ; S is color Style Attribute of the box
    ; ** note remember to reset the Style attribute after box is run If necessary
    
    ; L is the line number for the top of the box (0-22)
    ; If the Line you chose would cause the box to extend beyond the bottom of the
    ; screen, the box is automatically moved up the appropriate number of lines.
    
    ; C is calculated as starting column number
    
    ; W is the String value of the width of the + the characters ",AC"
    ;   it is used in the Format command
    
    ; WB is the String value of the width+6 and the characters ",AC"
    ;   it is used in the Format command to print the top and bottom border
    
    
    ;---------------------------------------------------- Error Checking
    
    If LEN(prompt1)>74 then
        prompt1=SUBSTR(Prompt1,1,74)
    Endif
    
    If LEN(prompt2)>74 then
        prompt2=SUBSTR(Prompt2,1,74)
    Endif
    
    If LEN(prompt3)>74 then
        prompt3=SUBSTR(Prompt3,1,74)
    Endif
    
    
    
    ;-- make sure box will not run off the bottom of the screen
    prompt_counter=0
    If ISASSIGNED(prompt1) then prompt_counter=Prompt_counter+1 
    Endif
    If ISASSIGNED(prompt2) then prompt_counter=Prompt_counter+1 
    Endif
    If ISASSIGNED(prompt3) then prompt_counter=Prompt_counter+1 
    Endif
    
    
    SWITCH
        CASE prompt_counter=3 AND L>20: L=20
        CASE prompt_counter=2 AND L>21: L=21
        CASE prompt_counter=1 AND L>22: L=22
    ENDSWITCH
    
    ;-- check for invalid attribute assignment
    SWITCH
        CASE  NOT ISASSIGNED(S) : S=112    ;--defaults to inverse video
        CASE  S>255 :S=112
    ENDSWITCH
    
    ;-- If L is left out, box will start at top of screen
    If NOT ISASSIGNED(L) then L=0 
    Endif
    
    
    ;-- end of error checking section
    ;----------------------------------------------------------------------------
    
    
    
    ;-- calculate format and column information as well as top and bottom of box
    
    ;-- checks for longest line
    width=0
    If ISASSIGNED(prompt1) then width=MAX(width,LEN(prompt1)) 
    Endif
    If ISASSIGNED(prompt2) then width=MAX(width,LEN(prompt2)) 
    Endif
    If ISASSIGNED(prompt3) then width=MAX(width,LEN(prompt3)) 
    Endif
    
    
    W="W"+STRVAL(width)+",AC"    ;-- sets format for maximum length prompt
    WB="W"+STRVAL(width+6)+",AC" ;-- allows for centering to and bottom borders
    C=INT((80-(width+6))/2)      ;-- starting column
    
    topline = " "+FILL("",width)+"ͻ "
    botline = " "+FILL("",width)+"ͼ "
    
    ;-- Display the box  -------------------------------------------------------
    
    STYLE ATTRIBUTE S
    
    
    @L,C   ?? FORMAT(WB,topline)
    L=L+1
    
    shadowrow = L
    shadowcol = c + LEN(topline)
    
    If ISASSIGNED(prompt1) AND prompt1<>"" then
        @L,C ?? "  "+FORMAT(W,prompt1)+"  "
        L=L+1
    Endif
    
    If ISASSIGNED(prompt2) AND prompt2<>"" then
        @L,C ?? "  "+FORMAT(W,prompt2)+"  "
        L=L+1
    Endif
    
    If ISASSIGNED(prompt3) AND prompt3<>"" then
        @L,C ?? "  "+FORMAT(W,prompt3)+"  "
        L=L+1
    Endif
    
    @L,C ?? FORMAT(WB,botline)
    L=L+1
    
    STYLE ATTRIBUTE 1
    
    botline = FILL(" ",LEN(topline))
    FOR n1 FROM shadowrow TO L
        @ n1,shadowcol
        ?? "  "
    ENDFOR
    @ L,C+2
    ?? botline
    STYLE
    
    @ L-2,shadowcol-3
    
    ;-- clean up
    
    
ENDPROC

Writelib "I:SVCPROC" Notice
Release Procs All
Release Vars All




; ͻ
;     Displays a message in the middle of the        
;     screen, alerting user of action needed or      
;     taken                                          
; ͼ


PROC Closed NoticePrmpt(prompt1,prompt2,prompt3,prompt4,S,P,L,TPict,AccType)
    
;PRIVATE w,wb,c,width,prompt_counter,topline,botline,shadowrow,shadowcol,n1,
;		response, TDflt, AccptRow, AccptCol
    
    
    ; prompt1 is the header line While prompt2  prompt3 and prompt4 are the
    ; text lines to be placed in the box.
    ; A  max of 74 characters is permitted to allow for border.
    ; If Len(Prompt#)>74 then Substr(Prompt#,1,74) will be used
    ; Any or all of the prompts may be used, the box height is adjusted accordingly.
    
    ; S is color Style Attribute of the box
	 ; P is the prompt color
    ; ** note remember to reset the Style attribute after box is run If necessary
    
    ; L is the line number for the top of the box (0-22)
    ; If the Line you chose would cause the box to extend beyond the bottom of the
    ; screen, the box is automatically moved up the appropriate number of lines.

	 ; TPict is the picture to use for validating the response in the format
	 ;	"{Yes,No}". The first option will be the default response.

	 ; AccType is the Data Type for the format command. Must be 
	 ;  alphanumeric: "A1", "A5", etc.
    
    ; C is calculated as starting column number
    
    ; W is the String value of the width of the + the characters ",AC"
    ;   it is used in the Format command
    
    ; WB is the String value of the width+6 and the characters ",AC"
    ;   it is used in the Format command to print the top and bottom border
    
    
    ;---------------------------------------------------- Error Checking

	 AccptCol = Len(Prompt4)+1
	 Prompt4 = Prompt4 + Fill(" ",Numval(Substr(AccType,2,Len(AccType)-1))+1)

    If LEN(prompt1)>74 then
        prompt1=SUBSTR(Prompt1,1,74)
    Endif
    
    If LEN(prompt2)>74 then
        prompt2=SUBSTR(Prompt2,1,74)
    Endif
    
    If LEN(prompt3)>74 then
        prompt3=SUBSTR(Prompt3,1,74)
    Endif
    
    If LEN(prompt4)>74 then
        prompt4=SUBSTR(Prompt4,1,74)
    Endif
    
    
    
    ;-- make sure box will not run off the bottom of the screen
    prompt_counter=4
    
    SWITCH
        CASE prompt_counter=4 AND L>19: L=19
    ENDSWITCH
    
    ;-- check for invalid attribute assignment
    SWITCH
        CASE  NOT ISASSIGNED(S) : S=112    ;--defaults to inverse video
        CASE  S>255 :S=112
    ENDSWITCH
    
    ;-- If L is left out, box will start at top of screen
    If NOT ISASSIGNED(L) then L=0 
    Endif
    
    
    ;-- end of error checking section
    ;----------------------------------------------------------------------------
    
    
    
    ;-- calculate format and column information as well as top and bottom of box
    
    ;-- checks for longest line
    width=0
    width=MAX(width,LEN(prompt1)) 
    width=MAX(width,LEN(prompt2)) 
    width=MAX(width,LEN(prompt3))
    width=MAX(width,LEN(prompt4)) 
    
    
    W="W"+STRVAL(width)+",AC"    ;-- sets format for maximum length prompt
    WB="W"+STRVAL(width+6)+",AC" ;-- allows for centering to and bottom borders
    C=INT((80-(width+6))/2)      ;-- starting column
    
    topline = " "+FILL("",width)+"ͻ "
    botline = " "+FILL("",width)+"ͼ "
    
    ;-- Display the box  -------------------------------------------------------
    
    STYLE ATTRIBUTE S
    
    
    @L,C   ?? FORMAT(WB,topline)
    L=L+1
    
    shadowrow = L
    shadowcol = c + LEN(topline)
    
    @L,C ?? "  "+FORMAT(W,prompt1)+"  "
    L=L+1

    @L,C ?? "  "+FORMAT(W,prompt2)+"  "
    L=L+1
    
    @L,C ?? "  "+FORMAT(W,prompt3)+"  "
    L=L+1
    
    @L,C ?? "  "+FORMAT(W,prompt4)+"  "
	 AccptRow = L
    L=L+1
    
    @L,C ?? FORMAT(WB,botline)
    L=L+1
    
    STYLE ATTRIBUTE 1
    
    botline = FILL(" ",LEN(topline))
    FOR n1 FROM shadowrow TO L
        @ n1,shadowcol
        ?? "  "
    ENDFOR
    @ L,C+2
    ?? botline
    
	 Style Attribute P
	 @ AccptRow, C+3+Int((Width+AccptCol+1)/2)
	 Accept AccType
	 	Picture TPict
		Default Substr(TPict,2,(Search(",",TPict)-2))
		Required
		TO response

	 Style
	 Return response
    
ENDPROC

Writelib "I:SVCPROC" NoticePrmpt
Release Procs All
Release Vars All


