; Vchecks2 Script
; Rick Alber, April 1986

PROC Pchoice(vtype,before)                ;Get current validity check
PRIVATE x                                 ;for current field
SELECT vtype
x = MENUCHOICE()
Esc
IF (x <> "") THEN                         ;Determine if validity check exists
  IF (device = "P" or device = "B") THEN  ;Display on printer
    IF NOT (vtype = "Required" and x = "No") THEN    ;Supress required = No
      PRINT "\n   ",FORMAT ("w9,AR",vtype)," -> ",x  ;Send val check to printer
    ENDIF
  ENDIF

  IF (device = "S" or device = "B") THEN   ;Display on screen
    @ R,C
    IF NOT (vtype = "Required" and x = "No") THEN    ;Suppress required = No
      ?? " ",FORMAT("w3",vtype),CHR(26)," ",x       ;Send val check to screen
      maxc = MAX(maxc,COL())  IF maxc >= 60 THEN maxc = -1 ENDIF  ;Wrap back
      R = R + 1
    ENDIF
    IF R >= 23 THEN                        ;Move cursor back to top of box
      @ 4,maxc+2 ?? ""  R = 5  C = maxc +2
    ENDIF
  ENDIF
  RETURN TRUE
ENDIF
RETURN FALSE                              ;If no val check, Exit proc

ENDPROC ;Pchoice

CLEAR                                     ;Routine to create opening screen
@ 5,0  STYLE REVERSE
? FORMAT("w80,ac","VCHECKS -- List a Table's Validity Checks")
STYLE
@ 8,0
TEXT
 VCHECKS enables you to list the current validity checks in force for a
 particular table in the current directory.  VCHECKS gives you the option of
 outputting the validity checks to the screen, your printer, or both.
ENDTEXT

STYLE INTENSE
@ 19,0
TEXT
  ͻ
                                                                          
  ͼ
ENDTEXT
STYLE

TableExists = False                       ;Get & check table name
WHILE TableExists = False
@ 20,5 ?? "Enter name of table to check (Ret to exit): " ACCEPT "A20" TO tname
  IF tname = ""
    THEN QUIT
  ENDIF
  IF ISTABLE(tname)                       ;Found table
    THEN TableExists = True  QUITLOOP
  ELSE BEEP                               ;Can't find table
    @ 20,5 ?? "                                                                    "
    @ 20,5 ?? "Table '",tname,"' not found - try again           "
    SLEEP 1500
    @ 20,5 ?? "                                                                    "
  ENDIF
ENDWHILE

@ 20,5 ?? "Enter 'P' for printer output, 'S' for screen or 'B' for both: "
ACCEPT "A1" PICTURE "{P,S,B}" TO device

WHILE device <> "S" and PRINTERSTATUS() <> True   ;Check printer
   @ 20,5 ?? "Printer not ready - Fix printer and press any key to continue   "
   x = GETCHAR()
ENDWHILE

VIEW tname
Editkey                                   ;Prepare table for testing
CtrlHome                                  ;validity checks and
Right                                     ;print or display
Menu {ValCheck}{Define}                   ;listing header
IF (device = "P" or device = "B")
  THEN PRINT "\nValidity checks for: ", table(), " Table \n"
ENDIF
IF (device = "S" or device = "B")
  THEN @ 2,0 CLEAR EOS

TEXT
 ͻ
                                                                            
 Ķ
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
                                                                            
 ͼ
ENDTEXT

   @ 3,(23-INT(LEN(tname)/2)) ?? "Validity Checks for the ",UPPER(tname)," Table"
ENDIF

R = 5  C = 1  maxc = 1                    ;Position cursor and set right margin

FOR i FROM 1 TO NFIELDS(TABLE())
  Enter                                   ;Select current field
  IF (device = "P" or device = "B")       ;Send field name to printer
    THEN PRINT "\n* ",field()," Field ";Print name of current field
  ENDIF
  IF (device = "S" or device = "B") THEN  ;Send field name to screen
    IF R >=22 THEN @ 4,maxc+2 ?? ""  R = 5  C = maxc +2 ENDIF ;Move to top
    @ R,C ?? "" STYLE INTENSE ?? "",field()
    maxc = MAX(maxc,COL()) STYLE  R = R + 1
    IF maxc >=60 THEN maxc = -1 ENDIF     ;Wrap back to left margin
  ENDIF
                   ;Get validity checks for current field
  Pchoice("LowValue",    TRUE)    ;Call Pchoice - get LowValue Val Check
  Pchoice("HighValue",   TRUE)    ;Call Pchoice - get HighValue Val Check
  Pchoice("Default",     TRUE)    ;Call Pchoice - get Default Val Check
  Pchoice("TableLookup", TRUE)    ;Call Pchoice - get TableLookup Val Check
  Pchoice("Picture",     TRUE)    ;Call Pchoice - get Picture Val Check
  Pchoice("Required",    TRUE)    ;Call Pchoice - get Required Val Check

  Esc                                     ;Back to Validity Check Menu
  Right                                   ;Next validity check
ENDFOR

CtrlHome
Do_it!                                    ;End edit session
IF (device = "P" or device = "B")         ;Form feed
  THEN PRINT "\f"
ENDIF
IF (device = "S" or device = "B")         ;Display end on screen
  THEN @ R,C ?? ""  STYLE INTENSE ?? "no more fields"  STYLE
ENDIF
ClearAll                                  ;Clear workspace
x = GETCHAR()                             ;Pause for keypress
